#include <cstdio>
#include <cstdlib>

struct {
	bool d[512];
	
	inline void put(int i) { d[i] = 1; }
	inline void clear(int i) { d[i] = 0; }
	inline bool get(int i) { return d[i]; }
	inline void set(int i, bool v) { d[i] = v; }
} rows[512], cols[512];

int latin[512][512];
int n, h;

int rx, ry;
void rec() {
	if(ry == n) {
		for(int cy = 0; cy < n; ++cy) {
			printf("%d", latin[0][cy]);
			for(int cx = 1; cx < n; ++cx) {
				printf(" %d", latin[cx][cy]);
			}
			printf("\n");
		}
		exit(0);
	}
	for(int i = 1; i <= n; ++i) {
		if(!rows[ry].get(i) && !cols[rx].get(i)) {
			rows[ry].put(i);
			cols[rx].put(i);
			latin[rx][ry] = i;
			
			++rx;
			if(rx == n) {
				rx = 0; ++ry;
				rec();
				rx = n-1; --ry;
			} else {
				rec();
				--rx;
			}
			
			rows[ry].clear(i);
			cols[rx].clear(i);
		}
	}
}

int min(int a, int b) { return a < b ? a : b; }
bool check(int x, int y, int k) {
	return !rows[y].get(k) && !cols[x].get(k);
}
int put(int x, int y, int k) {
	latin[x][y] = k;
	rows[y].put(k);
	cols[x].put(k);
}
int clear(int x, int y, int k) {
	rows[y].clear(k);
	cols[x].clear(k);
}

bool stupid() {
	for(int nn = h; nn < n; ++nn) {
		for(int i = h; i < nn; ++i) {
			for(int k = 1; k <= n; ++k) {
				if(check(nn, i, k)) {
					put(nn, i, k);
					break;
				}
			}
			if(!latin[nn][i]) return false;
		}
		for(int i = 0; i <= nn; ++i) {
			for(int k = 1; k <= n; ++k) {
				if(check(i, nn, k)) {
					put(i, nn, k);
					break;
				}
			}
			if(!latin[i][nn]) return false;
		}
	}
	return true;
}

int main() {
	scanf("%d%d", &h, &n);
	printf("%d\n",n);
	for(int y = 0; y < h; ++y) {
		for(int x = 0; x < n; ++x) {
			scanf("%d", &latin[x][y]);
			cols[x].put(latin[x][y]);
			rows[y].put(latin[x][y]);
		}
	}
	if(stupid()) {
		for(int y = 0; y < n; ++y) {
			printf("%d", latin[0][y]);
			for(int x = 1; x < n; ++x) {
				printf(" %d", latin[x][y]);
			}
			printf("\n");
		}
	} else {
		for(int y = h; y < n; ++y) {
			for(int x = 0; x < n; ++x) {
				clear(x, y, latin[x][y]);
			}
		}
		
		ry = h;
		rec();
	}
	return 0;
}
