#include <iostream>
#include <cmath>

using namespace std;

long double PI=3.1415926535897932384626433832795;
long double PPI=2*3.1415926535897932384626433832795;

struct solar
{
    int x, y, speed, direction;
    long double angle, angle_for_one_s;
    void makeAngle()
    { 
        angle=atan2(y, x); 
        if (angle < 0)
            angle+=PPI;
    }
    long long double r()
    { return sqrt(x*x+y*y); }
    void generate()
    {
        long double P=2*PI*r();
        long double S=speed;
        long double K=S/P;
        angle_for_one_s=K*PPI;
    }
};

int k;
solar A, B;

void solve()
{
    A.makeAngle();
    B.makeAngle();
    A.generate();
    B.generate();
    if (A.direction == B.direction)
    {
        if (A.angle_for_one_s > B.angle_for_one_s)
        {
            A.angle_for_one_s-=B.angle_for_one_s;
            B.angle_for_one_s=0;
        }
        else
        {
            B.angle_for_one_s-=A.angle_for_one_s;
            A.angle_for_one_s=0;
        }
    }
    else
    {
        B.angle_for_one_s+=A.angle_for_one_s;
        A.angle_for_one_s=0;
    }
    long double Angle;
    if (A.angle_for_one_s == 0)
    {
        if (B.direction == 1)
        {
            if (B.angle < A.angle)
                B.angle+=PPI;
            Angle=B.angle-A.angle;
        }
        if (B.direction == -1)
        {
            if (B.angle > A.angle)
                A.angle+=PPI;
            Angle=A.angle-B.angle;
        }
        cout << (int)((Angle+PPI*(k-1))/B.angle_for_one_s) << endl;
    }
    if (B.angle_for_one_s == 0)
    {
        if (A.direction == 1)
        {
            if (B.angle > A.angle)
                A.angle+=PPI;
            Angle=A.angle-B.angle;
        }
        if (A.direction == -1)
        {
            if (A.angle > B.angle)
                B.angle+=PPI;
            Angle=B.angle-A.angle;
        }
        cout << (int)((Angle+PPI*(k-1))/A.angle_for_one_s) << endl;
    }
}

void input()
{
    cin >> A.x >> A.y >> A.speed >> A.direction;
    cin >> B.x >> B.y >> B.speed >> B.direction;
    cin >> k;
}

int main()
{
    input();
    solve();
return 0;
}
