#include <cstdio>
#include <cstdlib>

#define min(a,b) ( (a) < (b) ) ? (a) : (b)

const int MAXN = 1<<9;

int N, n, m;
int a[MAXN][MAXN];

bool row[MAXN][MAXN<<1], col[MAXN][MAXN<<1];

void update_row (int r, int pos) {
     if (row[r][pos*2+1] && row[r][pos*2 + 2]) row[r][pos] = true;
        else row[r][pos] = false;
     if (!pos) return;
     update_row(r,(pos-1)>>1);
     }

void update_col (int c, int pos) {
     if (col[c][pos*2+1] && col[c][pos*2 + 2]) col[c][pos] = true;
        else col[c][pos] = false;
     if (!pos) return;
     update_col(c,(pos-1)>>1);
     }

void print_row (int r) {
     printf("r = %2d\n", r);
     for (int i = 0; i < 2*N-1; ++i)
         printf("%2d ", i);
     printf("\n");
     for (int i = 0; i < 2*N-1; ++i)
         printf("%2d ", row[r][i]);
     printf("\n");
     }

void print_col (int c) {
     printf("c = %2d\n", c);
     for (int j = 0; j < 2*N-1; ++j)
         printf("%2d ", j);
     printf("\n");
     for (int j = 0; j < 2*N-1; ++j)
         printf("%2d ", col[c][j]);
     printf("\n");
     }

void init (void) {
     scanf("%d%d", &m, &n);
     N = 1; while (N < n) N <<= 1;
     //printf("N=%d\n", N);
     
     int pos;
     for (int i = 1; i <= m; ++i) {
         //printf("i=%d\n", i);
         for (int j = 1; j <= n; ++j) {
             scanf("%d", &a[i][j]);
             pos = N-2+a[i][j];
             row[i][pos] = 1; update_row(i,(pos-1)>>1);
             //print_row(i);
             col[j][pos] = 1; update_col(j,(pos-1)>>1);
             //print_col(j);
             }
         }
     }

int in (int x, int y, int pos, int from) {
    if (row[x][pos] || col[y][pos]) return 2*N;
    
    int ret = 2*N;
    if (pos < N-1) {
            ret = min(in(x,y,pos*2+1,from),ret);
            ret = min(in(x,y,pos*2+2,from),ret);
            }
            else if (ret > from) ret = pos;
    return ret;
}

void print (void) {
     printf("%d\n", n);
     
     for (int i = 1; i <= n; ++i) {
         for (int j = 1; j < n; ++j)
             printf("%d ", a[i][j]);
         printf("%d\n", a[i][n]);
         }
     }

void solve (int x, int y) {
     if (y > n) { solve(x+1,1); return; }
     if (x > n) { print(); exit(0); }
     //printf("x=%d y=%d\n", x, y);
     
     for (int k = 0; k < n; ) {
         k = in(x,y,0,N-1);
         a[x][y] = k+2-N;
         //printf("a[x][y] = %d k = %d\n", a[x][y], k);
         if (k == 2*N) { a[x][y] = 0; continue; }
         if (row[x][k] || col[y][k]) { a[x][y] = 0; continue; }
         row[x][k] = 1; update_row(x,(k-1)>>1);
         //print_row(x);
         col[y][k] = 1; update_col(y,(k-1)>>1);
         //print_col(y);
         solve(x,y+1);
         row[x][k] = 0; update_row(x,(k-1)>>1);
         col[y][k] = 0; update_col(y,(k-1)>>1);
         }
     }

int main()
{
    init();
    solve(m+1,1);
    
return 0;
}
