#include <cmath>
#include <cstdio>
#include <algorithm>

const double L = 2*M_PI;

int k;
double w1, w2, s1, s2, T;

void init (void) {
     int x, y, v, d;
     scanf("%d%d%d%d", &x, &y, &v, &d); d = -d;
     w1 = v*v; w1 /= (x*x+y*y); w1 = sqrt(w1); w1 *= d;
     s1 = atan2(y,x);
     scanf("%d%d%d%d", &x, &y, &v, &d); d = -d;
     w2 = v*v; w2 /= (x*x+y*y); w2 = sqrt(w2); w2 *= d;
     s2 = atan2(y,x);
     scanf("%d", &k);
     if (w1 < w2) { std::swap(w1,w2); std::swap(s1,s2); }
     if (s1 < 0) s1 += L;
     if (s2 < 0) s2 += L;
     if (s2 < s1) s2 += L;
     //printf("w1 = %.3lf\nw2 = %.3lf\n", w1, w2);
     //printf("s1 = %.3lf\ns2 = %.3lf\n", s1, s2);
     }

void solve (void) {
     double dx = s2-s1, dt = dx/(w1-w2);
     //printf("dx=%.3lf dt=%.3lf\n", dx, dt);
     T = L*(k-1); T /= (w1-w2); T += dt;
     //printf("T=%.3lf\n", T);
     printf("%d\n", (int)floor(T));
     }

int main()
{
    init();
    solve();
    
return 0;
}
